/* © 2024 Appstock */

import UIKit

import AppstockSDK
import GoogleMobileAdsAppstockAdapter

import GoogleMobileAds

fileprivate let adUnitId = "ca-app-pub-2844566227051243/6987265190"

final class AdMobBannerInterstitialViewController: InterstitialBaseViewController {
    
    private var interstitialAd: GADInterstitialAd!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        loadAd()
    }
    
    private func loadAd() {
        // 1. Load the interstitial ad
        GADInterstitialAd.load(withAdUnitID: adUnitId, request: GADRequest()) { [weak self] ad, error in
            guard error == nil && ad != nil else {
                return
            }
            
            self?.interstitialAd = ad
            
            // 2. Configure the interstitial ad
            self?.interstitialAd.fullScreenContentDelegate = self
            
            // 3. Present the interstitial ad
            self?.interstitialAd.present(fromRootViewController: self)
        }
    }
}

// MARK: - GADFullScreenContentDelegate

extension AdMobBannerInterstitialViewController: GADFullScreenContentDelegate {
    
    func ad(_ ad: any GADFullScreenPresentingAd, didFailToPresentFullScreenContentWithError error: any Error) {
        print("Did fail to receive ad with error: \(error.localizedDescription)")
    }
}
