/* © 2024 Appstock */

import UIKit

import AppstockSDK
import GoogleMobileAdsAppstockAdapter

import GoogleMobileAds

fileprivate let adUnitId = "ca-app-pub-2844566227051243/4782448263"

final class AdMobVideoRewardedViewController: InterstitialBaseViewController {
    
    private var rewardedAd: GADRewardedAd!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        loadAd()
    }
    
    private func loadAd() {
        // 1. Load the rewarded ad
        GADRewardedAd.load(withAdUnitID: adUnitId, request: GADRequest()) { [weak self] ad, error in
            guard error == nil && ad != nil else {
                return
            }
            
            self?.rewardedAd = ad
            
            // 2. Configure the rewarded ad
            self?.rewardedAd.fullScreenContentDelegate = self
            
            // 3. Present the rewarded ad
            self?.rewardedAd.present(fromRootViewController: self, userDidEarnRewardHandler: {
                print("User did earn reward.")
            })
        }
    }
}

// MARK: - GADFullScreenContentDelegate

extension AdMobVideoRewardedViewController: GADFullScreenContentDelegate {
    
    func ad(_ ad: any GADFullScreenPresentingAd, didFailToPresentFullScreenContentWithError error: any Error) {
        print("Did fail to receive ad with error: \(error.localizedDescription)")
    }
}
